// ciklus.h - Klasa ciklusa.

#ifndef _ciklus_h_
#define _ciklus_h_

#include "izraz.h"
using namespace Izrazi;
#include "naredba.h"

namespace Naredbe {
  class Ciklus: public Naredba {
    Izraz*   izr;                            // Uslov ciklusa.
    Naredba* nar;                            // Sadraj ciklusa.
    void kopiraj(const Ciklus& c)            // Kopiranje u objekat.
      { izr = c.izr->kopija(); nar = c.nar->kopija(); }
    void brisi() { delete izr; delete nar; } // Oslobadanje memorije.
    void pisi(ostream& it) const {           // Pisanje.
      Naredba::pisi(it); it << "while(" << *izr << ")\n";
      nivo++; it << *nar; nivo--;
    }
  public:
    Ciklus(const Izraz& i, const Naredba& n)         // Inicijalizacija.
      { izr = i.kopija(); nar = n.kopija(); }
    Ciklus(const Ciklus& s) { kopiraj(s); }          // Konstruktor kopije.
    ~Ciklus() { brisi(); }                           // Unitavanje.
    Ciklus& operator=(const Ciklus& s) {             // Dodela vrednosti.
      if (this != &s) { brisi(); kopiraj(s); }
      return *this;
    }
    void radi() const;                               // Izvravanje.
    Ciklus* kopija() const { return new Ciklus(*this); } // Kopiranje.
  }; // class Ciklus
} // namespace Naredbe

#endif
