// font.h - Klasa fontova.

#ifndef _font_h_
#define _font_h_

#include "simbol.h"
#include <iostream>
using namespace std;

class GNema {};                            // KLASA GREAKA: Nema simbola.
inline ostream& operator<<(ostream& it, const GNema&)
  { return it << "*** Nema simbola! ***"; }

class Font {                               // KLASA FONTOVA:
  struct Elem {                            // Element liste simbola.
    Simbol sim; Elem* sled;
    Elem(const Simbol& s): sim(s) { sled = 0; }
  };
  Elem *prvi, *posl;                       // Prvi i poslednji element.
  int brSimb;                              // Duina liste.
  void kopiraj(const Font& f);             // Kopiranje u objekat.
  void brisi();                            // Brisanje objekta.
public:
  Font() { prvi = posl = 0; brSimb = 0; }  // Inicijalizacija.
  Font(const Font& f) { kopiraj(f); }      // Konstruktor kopije.
  ~Font() { brisi(); }                     // Destruktor.
  Font& operator=(const Font& f) {         // Dodela vrednosti.
    if (this != &f) { brisi(); kopiraj(f); }
    return *this;
  }
  int brSimbola() const { return brSimb; } // Broj simbola.
  Simbol& operator[](char zn);             // Pristup simbolu promenljivog
  const Simbol& operator[](char zn) const  // ... i nepromenljivog fonta.
    { return const_cast<Font&>(*this)[zn]; }
  Font& operator+=(const Simbol& s) {      // Dodavanje simbola:
    try {                                  // - zamena postojeceg,
      (*this)[s.znak()] = s;
    } catch (GNema) {                      // - dodavanje novog.
      brSimb++;
      posl = (!prvi ? prvi : posl->sled) = new Elem(s);
    }
    return *this;
  }
};

#endif
