// grupa.C - Metode klase grupa elektricnih potroaca.

#include "grupa.h"

namespace Potrosaci {
  void Grupa::kopiraj(const Grupa& g) {      // Kopiranje u objekat.
    prvi = posl = 0;
    for (Elem* tek=g.prvi; tek; tek=tek->sled) {
      Elem* novi = new Elem(tek->potr->kopija());
      posl = (!prvi ? prvi : posl->sled) = novi;
    }
    sna = g.sna;
  }

  void Grupa::brisi() {                      // Brisanje objekta.
    while (prvi) { Elem* stari = prvi; prvi = prvi->sled; delete stari; }
    posl = 0;
  }

  void Grupa::pisi(ostream& it) const {      // Pisanje.
    it << '[';
    for (Elem* tek=prvi; tek; tek=tek->sled)
      { it << *tek->potr; if (tek->sled) it << ','; }
    it << ']';
  }
} // namespace
