// linija.h - Apstraktna klasa linija u ravni.

#ifndef _linija_h_
#define _linija_h_

#include <iostream>
using namespace std;

namespace Linije {
  class Linija {
    static int posId;                     // Poslednji identifikator.
    int id;                               // Identifikator linije.
  public:
    Linija(): id(++posId) {}              // Nova linija dobija nov broj.
    Linija(const Linija&): id(++posId) {} // Kopija dobija nov broj.
    Linija& operator=(const Linija&)      // Levom operandu se ne menja
      { return *this; }                   //   broj.
    virtual ~Linija() {}                  // Virtuelan destruktor.
    virtual double duzina() const =0;     // Duina linije.
    virtual Linija* kopija() const =0;    // Kopiranje.
  protected:
    virtual void pisi(ostream& it) const { it << id; } // Pisanje.
    friend ostream& operator<<(ostream& it, const Linija& lin)
      { lin.pisi(it); return it; }
  };
}

#endif
