// mattacka.h - Definicija klase materijalnih tacaka.

#include <iostream>
#include <cmath>
using namespace std;

class MatTacka {
  double m, x, y, z;                          // Masa i koordinate tacke.
public:
  explicit MatTacka(double mm=1, double xx=0, // Stvaranje tacke.
                    double yy=0, double zz=0)
    { m = mm; x = xx; y = yy; z = zz;  }
  double r(const MatTacka& T) const           // Rastojanje do tacke.
    { return sqrt(pow(x-T.x,2) + pow(y-T.y,2) + pow(z-T.z,2)); }
  double F(const MatTacka& T) const           // Privlacna sila.
    { return 6.67e-11 * m * T.m / pow(r(T),2); }
  void pisi() const                           // Pisanje tacke.
    { cout << '[' << m << ",(" << x << ',' << y << ',' << z <<")]"; }
};
