// niz5.h - Genericka klasa nizova.

#ifndef _niz5_h_
#define _niz5_h_

#include <iostream>
using namespace std;

class GNizPun {};                  // KLASA GREAKA: Niz je prepunjen.
inline ostream& operator<<(ostream& it, const GNizPun&)
  { return it << "*** Niz je pun! ***"; }


class GIndeks {};                  // KLASA GREAKA: Indeks izvan opsega.
inline ostream& operator<<(ostream& it, const GIndeks&)
  { return it << "*** Nedozvoljen indeks! ***"; }

template <typename T>                        // GENERICKA KLASA NIZOVA:
class Niz {
  T* niz;                                    // Elementi niza.
  int kap, duz;                              // Kapacitet i duina niza.
  void kopiraj(const Niz& n);                // Kopiranje u objekat.
  void brisi() { delete [] niz; }            // Brisanje objekta.
public:
  explicit Niz(int k=20) {                   // Stvaranje praznog niza.
    niz = new T [kap = k];
    duz = 0;
  }
  Niz(const Niz& n) { kopiraj(n); }          // Konstruktor kopije.
  ~Niz() { brisi(); }                        // Destruktor.
  Niz& operator=(const Niz& n){              // Dodela vrednosti.
    if (this!=&n) { brisi(); kopiraj(n); }
    return *this;
  }
  int duzina() const { return duz; }         // Duina niza.
  Niz& operator+=(const T& e) {              // Dodavanje elementa.
    if (duz == kap) throw GNizPun();
    niz[duz++] = e;
    return *this;
  }
 
  T& operator[](int i) {                     // Pristup elementu
    if (i<0 || i>=duz) throw GIndeks();      // - promenljivog niza,
    return niz[i];
  }
  const T& operator[](int i) const {         // - nepromenljivog niza.
    if (i<0 || i>=duz) throw GIndeks();
    return niz[i];
  }
};

template <typename T>                        // METODA KLASE NIZOVA:
void Niz<T>::kopiraj(const Niz& n) {         // Kopiranje u objekat.
  niz = new T [kap = n.kap];
  duz = n.duz;
  for (int i=0; i<duz; i++) niz[i] = n.niz[i];
}

#endif
