// niz6.h - Genericka klasa nizova pokazivaca na elemente.

#ifndef _niz6_h_
#define _niz6_h_

#include <iostream>
using namespace std;

class GIndeks {};             // KLASA GREAKA: Nedozvoljen indeks.
inline ostream& operator<<(ostream& it, const GIndeks&)
  { return it << "*** Nedozvoljen indeks! ***"; }

class GPun {};                // KLASA GREAKA: Niz je pun.
inline ostream& operator<<(ostream& it, const GPun&)
  { return it << "*** Niz je pun! ***"; }

template <typename T>         // GENERICKA KLASA NIZOVA:
class Niz {
  T** niz;                    // Niz pokazivaca na elemente.
  int kap, duz;               // Kapacitet i duina niza.
  void kopiraj(const Niz& n); // Kopiranje u objekat.
  void brisi();               // Brisanje objekta.
public:
  explicit Niz(int k=10)                // Stvaranje praznog niza.
    { niz = new T* [kap = k]; duz = 0; }
  Niz(const Niz& n) { kopiraj(n); }     // Konstruktor kopije.
  ~Niz() { brisi(); }                   // Destruktor.
  Niz& operator=(const Niz& n) {        // Dodela vrednosti.
    if (this != &n) { brisi(); kopiraj(n); }
    return *this;
  }
  int duzina() const { return duz; }    // Duina niza.
  Niz& operator+=(T* t) {               // Preuzimanje elementa po adresi.
    if (duz == kap) throw GPun();
    niz[duz++] = t;
    return *this;
  }
  T& operator[](int i) {                // Pristup elementu
    if (i<0 || i>=duz) throw GIndeks(); // - promenljivog niza,
    return *niz[i];
  }
  const T& operator[](int i) const {    // - nepromenljivog niza.
    if (i<0 || i>=duz) throw GIndeks();
    return *niz[i];
  }
};

template <typename T>                   // METODE KLASE NIZOVA:
void Niz<T>::kopiraj(const Niz& n) {    // Kopiranje u objekat.
  niz = new T* [kap = n.kap];
  duz = n.duz;
  for (int i=0; i<duz; i++) niz[i] = n.niz[i]->kopija()
}

template <typename T>
void Niz<T>::brisi() {                  // Brisanje objekta.
  for (int i=0; i<duz; delete niz[i++]);
  delete [] niz;
}

#endif
