// nizmtac.C - Definicije metoda klase nizova materijalnih tacaka.

#include "nizmtac.h"
#include <iostream>
using namespace std;

NizMTac::NizMTac(const NizMTac& n) {              // Konstruktor kopije.
  niz = new MatTacka [kap = n.kap];
  duz = n.duz;
  for (int i=0; i<duz; i++) niz[i] = n.niz[i];
}

NizMTac& NizMTac::dodaj(const MatTacka& T) {      // Dodavanje tacke.
  if (duz == kap) {
    MatTacka* pom = new MatTacka [kap += 5];
    for (int i=0; i<duz; i++) pom[i] = niz[i];
    delete [] niz; niz = pom;
  }
  niz[duz++] = T;
  return *this;
}

MatTacka NizMTac::maxF(const MatTacka& T) const { // Najjaca tacka.
  double max = T.F(niz[0]);
  int ind = 0;
  for (int i=1; i<duz; i++) {
    double F = T.F(niz[i]);
    if (F > max) { max = F; ind = i; }
  }
  return niz[ind];
}

void NizMTac::pisi() const {                      // Pisanje niza.
  for (int i=0; i<duz; i++) { niz[i].pisi(); cout << endl; }
}
