// osoba.h - Klasa osoba.

#ifndef _osoba_h_
#define _osoba_h_

#include <cstring>
#include <iostream>
using namespace std;

class Osoba {
  char* ime;                                      // Ime osobe.
  float tez;                                      // Teina osobe.
  Osoba(const Osoba&);                            // Ne sme da se kopira.
  Osoba& operator=(const Osoba&);                 // Ne sme da se dodeljuje.
public:                                          
  explicit Osoba(const char* iime, float ttez) {  // Konstruktor.
    ime = strcpy(new char [strlen(iime)+1], iime);
    tez = ttez;
  }
  ~Osoba() { delete [] ime; }                     // Destruktor.
  const char* dohvIme() const { return ime; }     // Dohvatanje imena.
  float dohvTez() const { return tez; }           // Dohvatanje teine.
  friend ostream& operator<<(ostream& it, const Osoba& osoba) // Pisanje.
    { return it << osoba.ime << '(' << osoba.tez << ')'; }
};

#endif
