// predstava.h - Klasa predstava.

#include "karta.h"
#include <iostream>
using namespace std;

class Predstava {
  char* naslov;                        // Naslov.
  long datum;                          // Datum odravanja.
  Karta*** karte;                      // Matrica karata.
  int brRed, duzRed;                   // Broj redova i duina redova.
  void kopiraj(const Predstava& p);    // Kopiranje u objekat.
  void brisi();                        // Unitavanje objekta.
public:                                             // Konstrutori:
  Predstava(const char* nas, long dat,              // - novog objekta,
            int brR, int duzR);
  Predstava(const Predstava& p)                     // - kopije.
    { kopiraj(p); }
  ~Predstava() { brisi(); }                         // Destruktor.
  Predstava& operator=(const Predstava& p) {        // Dodela vrednosti.
    if (this != &p) { brisi(); kopiraj(p); }
    return *this;
  }                                                 // Dohvatanje:
  const char* dohvNaslov() const { return naslov; } // - naslova,
  long dohvDatum() const {return datum;}            // - datuma,
  int dohvBrRed() const {return brRed;}             // - broja redova,
  int dohvDuzRed() const {return duzRed;}           // - duine redova.
  bool operator+=(const Karta& k);                  // Dodavanje karte.
  float vrednost() const;                           // Vrednost svih karata.
  friend ostream& operator<<(ostream& it, const Predstava& p); // Pisanje.
};
