// proizvod1.h - Apstraktna klasa proizvoda.

#ifndef _proizvod1_h_
#define _proizvod1_h_

#include <iostream>
using namespace std;

namespace Fabrika {
  class Proizvod {
    static int posId;       // Poslednji identifikator.
    int id;                 // Identifikator objekta.
  public:
    Proizvod() { id = ++posId; }         // Nov objekat dobija nov broj.
    Proizvod(const Proizvod&) { id = ++posId; } // Kopija dobija nov broj.
    virtual ~Proizvod() {}               // Virtuelan destruktor.
    Proizvod& operator=(const Proizvod&) // Levom operandu se ne menja br.
      { return *this; }
    int dohvId() const { return id; }    // Dohvatanje identifikatora.
    virtual char vrsta() const =0;       // Oznaka vrste proizvoda.
    virtual double V() const =0;         // Zapremina proizvoda.
  protected:
    virtual void pisi(ostream& it) const { it << vrsta() << id; }// Pisanje.
    friend ostream& operator<<(ostream& it, const Proizvod& p)
      { p.pisi(it); return it; }
  }; // class Proizvod
} // namespace Fabrika

#endif
