// pvagon.h - Klasa putnickih vagona.

#ifndef _pvagon_h_
#define _pvagon_h_

#include "vozilo2.h"
#include <iostream>
using namespace std;

namespace Vozovi1 {
  class GPrevisePutnika {};         // KLASA GREAKA: Previe putnika.
  inline ostream& operator<<(ostream& it, const GPrevisePutnika&)
    { return it << "*** Previse putnika! ***"; }

  class PVagon: public Vozilo {    // KLASA PUTNICKIH VAGONA:
    static float srTezPut;         // Srednja teina putnika.
    int kap, brPut;                // Kapac. vagona i trenutni broj putn.
    void pisi(ostream& it) const { // Pisanje.
      Vozilo::pisi(it); it << '(' << brPut << ','
                           << brPut*srTezPut << ')';
    }
  public:
    static const char VR = 'P';              // Oznaka putnickih vagona.
    static void postaviSrTezPut(float stp)   // Postavljanje sr. te. putn.
      { srTezPut = stp; }
    static float dohvatiSrTezPut()           // Dohvatanje sr. te. putn.
      { return srTezPut; }
    PVagon(float sopTez, int k=50): Vozilo(sopTez)     // Konstruktor.
      { kap = k; brPut = 0; }
    char vrsta() const { return VR; }                  // Oznaka vrste.
    float ukTezina() const                             // Ukupna teina.
      { return sopTezina() + brPut*srTezPut; }
    PVagon* kopija() const                             // Kopiranje.
      { return new PVagon(*this); }
    PVagon& ulazePutnici(int broj) {                   // Ulazak putnika.
      if (brPut+broj > kap) throw GPrevisePutnika();
      brPut += broj; return *this;
    }
    PVagon& izlazePutnici(int broj) {                  // Izlazak putnika.
      brPut = (broj <= brPut) ? brPut-broj : 0;
      return *this;
    }
  }; // class
} // namespace

#endif
