// redtela.C - Metode i funkcije uz klasu redova tela.

#include "redtela.h"

RedTela::RedTela(int k) {                  // Konstruktor praznog reda.
  tela = new Telo* [kap = k];
  for (int i=0; i<kap; tela[i++]=0);
  prvo = posl = duz = 0;
}

void RedTela::kopiraj(const RedTela& r) {  // Kopiranje u objekat.
  tela = new Telo* [kap = r.kap];
  for (int i=0; i<kap; i++)
    tela[i] = r.tela[i] ? r.tela[i]->kopija() : 0;
  prvo = r.prvo; posl = r.posl; duz  = r.duz;
}

void RedTela::brisi() { // Brisanje objekta.
  for (int i=0; i<kap; delete tela[i++]);
  delete [] tela;
}

ostream& operator<<(ostream& it, // Pisanje.
                    const RedTela& r) {
  it << "red[";
  for (int i=0; i<r.duz; i++) {
    if (i) it << ',';
    it << *r.tela[(r.prvo+i)%r.kap];
  }
  return it << ']';
}
