// redtela.h - Klasa redova tela.

#ifndef _redtela_h_
#define _redtela_h_

#include "telo1.h"
#include <iostream>
#include <cstdlib>
using namespace std;

class RedTela {
  Telo** tela;                           // Niz tela.
  int kap, duz;                          // Kpacacitet i duina reda.
  int prvo, posl;                        // Prvo i poslednje telo.
  void kopiraj(const RedTela&);          // Kopiranje u objekat.
  void brisi();                          // Brisanje objekta.
public:
  explicit RedTela(int k=5);             // Konstruktori.
  RedTela(const RedTela& r) { kopiraj(r); }
  ~RedTela() { brisi(); }                // Destruktor.
  RedTela& operator=(const RedTela& r) { // Dodela vrednoszi.
    if (this != &r) { brisi(); kopiraj(r); }
    return *this;
  }
  bool pun() { return duz == kap; }      // Da li je pun?
  bool prazan() { return duz == 0; }     // Da li je prazan?
  RedTela& operator+=(const Telo& t) {   // Dodvanje tela na kraj.
    if (duz == kap) exit(1);
    tela[posl++] = t.kopija(); if (posl == kap) posl = 0;
    duz++;
    return *this;
  }
  Telo* uzmi() {                         // Uzimanje tela sa pocetka.
    if (duz == 0) exit(2);
    Telo* t = tela[prvo];
    tela[prvo++] = 0; if (prvo == kap) prvo = 0;
    duz--;
    return t;
  }
  friend ostream& operator<<(ostream&, const RedTela&); // Piasnje.
};

#endif
