// skuptroug.C - Metode i funkcije uz klasu trouglova u ravni.

#include "skuptroug.h"

void SkupTroug::kopiraj(const SkupTroug& s) { // Kopiranje u objekat.
  prvi = posl = 0;
  for (Elem *tek=s.prvi; tek; tek=tek->sled)
    posl = (!prvi ? prvi : posl->sled) = new Elem(tek->t);
}

void SkupTroug::brisi() {                     // Brisanje objekta.
  while (prvi) { Elem* stari = prvi; prvi = prvi->sled; delete stari; }
  posl = 0;
}

bool SkupTroug::ima(const Trougao& t) const { // Da li postoji u skupu?
  for (Elem* tek=prvi;tek;tek=tek->sled)
    if (tek->t == t) return true;
  return false;
}

SkupTroug& SkupTroug::operator+=(const Trougao& t){ // Dodavanje trougla.
  if (!ima(t)) posl = (!prvi ? prvi : posl->sled) = new Elem(t);
  return *this;
}

double SkupTroug::ukP() const {               // Ukupna povrina trouglova.
  double p = 0;
  for (Elem* tek=prvi;tek;tek=tek->sled) p += tek->t.P();
  return p;
}

ostream& operator<<(ostream& it, const SkupTroug& s) { // Pisanje.
  it << '{';
  for (SkupTroug::Elem* tek=s.prvi; tek; tek=tek->sled) {
    it << tek->t;
    if (tek->sled) it << ',';
  }
  return it << '}';
}
