// tekst4.h - Klasa tekstova.

#ifndef _tekst4_h_
#define _tekst4_h_

#include "figura4.h"
#include "vektor4.h"
#include "Font.h"
#include <iostream>
using namespace std;

class Tekst: public Figura {
  char* tks;                                          // Sadrani tekst.
  double vis;                                         // Visina znakova.
  Font fnt;                                           // Koriceni font.
  Vektor poz;                                         // Poloaj u ravni.
  void pisi(ostream& it) const                        // Pisanje.
    { it << tks << '[' << poz << ',' << vis << ',' << sirina() << ']'; }
public:
  Tekst(const char* tks, double h, const Font& f,     // Inicijalizacija.
        const Vektor& p): fnt(f), poz(p) {
    this->tks = strcpy(new char[strlen(tks)+1], tks);
    vis = h;
  }
  Tekst(const Tekst& t): fnt(t.fnt), poz(t.poz) {     // Konstruktor kopije.
    tks = strcpy(new char [strlen(t.tks)+1], t.tks);
    vis = t.vis;
  }
  ~Tekst() { delete [] tks; }                         // Destruktor.
  Tekst& operator=(const Tekst& t) {                  // Dodela vrednosti.
    if (this != &t) {
      tks = strcpy(new char [strlen(t.tks)+1], t.tks);
      vis = t.vis; fnt = t.fnt; poz = t.poz;
    }
  }
  double visina() const { return vis; }               // Visina znakova. 
  double sirina() const;                              // irina teksta.
 
  Tekst& operator+=(const Vektor& v)                  // Pomeranje.
    { poz += v; return *this; }
  Tekst* kopija() const { return new Tekst(*this); }  // Kopiranje.
};

#endif
