// teret.h - Apstraktna klasa tereta.

#ifndef _teret_h_
#define _teret_h_

#include <iostream>
using namespace std;

class Teret {
  static int posId;                     // Poslednji identifikator.
  int id;                               // Identifikator tereta.
  double sigma;                         // Specificna teina.
public:
  explicit Teret(double s=1)            // Nov objekat dobija nov ident.
    { id = ++posId; sigma = s; }
  Teret(const Teret& t)                 // Kopija dobija nov identifikator.
    { id = ++ posId; sigma = t.sigma; }
  virtual ~Teret() {}                   // Virtuelan destruktor.
  Teret& operator=(const Teret& t)      // Levom operandu se ne menja id.
    { sigma = t.sigma; }
  virtual char vrsta() const =0;        // Oznaka vrste.
  virtual Teret* kopija() const =0;     // Kopiranje.
  virtual double zapr() const =0;       // Zapremina.
  double tezina() const { return zapr() * sigma; }        // Teina.
  friend ostream& operator<<(ostream& it, const Teret& t) // Pisanje.
    { return it << t.vrsta() << t.id; }
};

#endif
