// tkackiauto.h - Klasa trkackog automobila.

#ifndef _tkackiauto_h_
#define _tkackiauto_h_

#include "vozilo3.h"
#include "niz5.h"
#include "voznja.h"
#include "etapa.h"

class TrkackiAuto: public Vozilo {
  Niz<Voznja> voznje;                        // Niz vonji.
public:
  TrkackiAuto(float sTez, int kap)           // Stvaranje automobila.
    : Vozilo(sTez), voznje(kap) {}
  const char* vrsta() const { return "Trkacki auto"; } // Naziv vrste.
  TrkackiAuto& novaVoznja(int kap) {         // Pocetak nove vonje.
    voznje += Voznja(kap); 
    return *this;
  }
  TrkackiAuto& dodajEtapu(const Etapa& e) {  // Dodavanje nove etape.
    voznje[voznje.duzina()-1] += e;
    return *this;
  }
  const Voznja& najbrza() const;             // Nalaenje najbre vonje.
};

#endif
