// zbirfun.h - Klasa zbirova funkcija.

#ifndef _zbirfun_h_
#define _zbirfun_h_

#include "fun3.h"
#include <cmath>
using namespace std;

namespace Izvodi {
  class GZbirFunPun {};             // KLASA GREAKA: Zbir funkcija je pun.
  inline ostream& operator<<(ostream& it, GZbirFunPun)
    { return it << "*** Zbir funkcija je pun! ***\n"; }

  class ZbirFun: public Fun {       // KLASA ZBIROVA FUNKCIJA:
    Fun** niz;                      // Niz funkcija.
    int kap, duz;                   // Kapacitet i broj popunjenih mesta.
    void pisi(ostream& it) const;              // Pisanje.
    void kopiraj(const ZbirFun&);              // Kopiranje u objekat.
    void brisi();                              // Oslobadanje memorije.
  public:
    explicit ZbirFun(int n=2)                  // Inicijalizacija.
      { niz = new Fun* [kap = n]; duz = 0; }
    ZbirFun(const ZbirFun& z) { kopiraj(z); }  // Konstruktor kopije.
    ~ZbirFun() { brisi(); }                    // Unitavanje.
    ZbirFun& operator=(const ZbirFun& z){      // Dodela vrednosti.
      if (this != &z) { brisi(); kopiraj(z); }
      return *this;
    }
    ZbirFun& operator+=(const Fun& f) {        // Dodavanje funkcije
      if (duz == kap) throw GZbirFunPun();     //   po vrednosti.
      niz[duz++] = f.kopija();
      return *this;
    }
    ZbirFun& operator+=(Fun* f) {            // Dodavanje funkcije
      if (duz == kap) throw GZbirFunPun();   //   po adresi.
      niz[duz++] = f;
      return *this;
    }
    double operator()(double x) const;       // Racunanje vrednosti.
    Delegat izvod() const;                   // Stvaranje izvoda.
    ZbirFun* kopija() const                  // Kopiranje.
      { return new ZbirFun(*this); }
  }; // class ZbirFun
} // namespace Izvodi

#endif
